ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.2 by root, Mon Dec 6 20:53:44 2010 UTC vs.
Revision 1.33 by root, Thu Feb 24 07:10:03 2011 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6PERLVER=5.12.2 # 5.8.9 is also a good choice
7STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
8CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
9EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
10 9
11MKBUNDLE="$STATICPERL/mkbundle"
12
13# perl build variables 10# perl build variables
14PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
15PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
28 ;; 28 ;;
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 36
37# some configuration options for modules 37# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
41 42
42# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
43# required by mkbundle 44# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 46
46# which extra modules you might want to install 47# which extra modules you might want to install
47EXTRA_MODULES="" 48EXTRA_MODULES=""
48 49
49# overridable functions 50# overridable functions
51preconfigure() { : ; }
50postconfigure() { : ; } 52postconfigure() { : ; }
51postbuild() { : ; } 53postbuild() { : ; }
52postinstall() { : ; } 54postinstall() { : ; }
53 55
54# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
55[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
56[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
57[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
58 64
59############################################################################# 65#############################################################################
60# support 66# support
67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
72LC_ALL=C; export LC_ALL # just to be on the safe side
61 73
62# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
63VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
64$VERSION=0.1 76$VERSION="1.1"
65 77
66BZ2=bz2 78BZ2=bz2
67BZIP2=bzip2 79BZIP2=bzip2
68 80
69fatal() { 81fatal() {
102############################################################################# 114#############################################################################
103# clean 115# clean
104 116
105distclean() { 117distclean() {
106 verblock <<EOF 118 verblock <<EOF
107deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
108EOF 120EOF
109 121
110 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
111} 123}
112 124
113############################################################################# 125#############################################################################
114# download/configure/compile/install perl 126# download/configure/compile/install perl
115 127
116clean() { 128clean() {
117 cd "$STATICPERL/src/perl-$PERLVER" 2>/dev/null || return 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
118 131
119 rm -f staticstamp.configure 132realclean() {
120 make distclean >/dev/null 2>&1 133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
121} 136}
122 137
123fetch() { 138fetch() {
124 rcd "$STATICPERL" 139 rcd "$STATICPERL"
125 140
126 mkdir -p src 141 mkdir -p src
127 rcd src 142 rcd src
128 143
129 if ! [ -d "perl-$PERLVER" ]; then 144 if ! [ -d "perl-$PERL_VERSION" ]; then
130 if ! [ -e "perl-$PERLVER.tar.$BZ2" ]; then 145 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then
131 146
132 URL="$CPAN/src/5.0/perl-$PERLVER.tar.$BZ2" 147 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2"
133 148
134 verblock <<EOF 149 verblock <<EOF
135downloading perl 150downloading perl
136to manually download perl yourself, place 151to manually download perl yourself, place
137perl-$PERLVER.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
138trying $URL 153trying $URL
139EOF 154EOF
140 155
156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
141 curl >perl-$PERLVER.tar.$BZ2~ "$URL" \ 157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || wget -O perl-$PERLVER.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: error during downloading" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERLVER.tar.$BZ2~ perl-$PERLVER.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 162 fi
146 163
147 verblock <<EOF 164 verblock <<EOF
148unpacking perl 165unpacking perl
149EOF 166EOF
150 167
151 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERLVER.tar.bz2 | tar xpC unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \
153 || fatal "perl-$PERLVER.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION
154 mv unpack/perl-$PERLVER perl-$PERLVER 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
155 rmdir -p unpack 174 rmdir -p unpack
156 fi 175 fi
157} 176}
158 177
159# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
160sedreplace() { 179sedreplace() {
161 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
162 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
163} 209}
164 210
165configure() { 211configure() {
166 fetch 212 fetch
167 213
168 rcd "$STATICPERL/src/perl-$PERLVER" 214 rcd "$STATICPERL/src/perl-$PERL_VERSION"
169 215
170 [ -e staticstamp.configure ] && return 216 [ -e staticstamp.configure ] && return
171 217
172 verblock <<EOF 218 verblock <<EOF
173configuring $STATICPERL/src/perl-$PERLVER 219configuring $STATICPERL/src/perl-$PERL_VERSION
174EOF 220EOF
175 221
176 clean
177
178 rm -f "$PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
179 223
224 "$MAKE" distclean >/dev/null 2>&1
225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
180 # I hate them 228 # I hate them for this
181 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
182 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231
232 preconfigure
183 233
184# trace configure \ 234# trace configure \
185 sh Configure -Duselargefiles \ 235 sh Configure -Duselargefiles \
186 -Uuse64bitint \ 236 -Uuse64bitint \
187 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
188 -Uusedl \ 238 -Uusedl \
189 -Uusethreads \ 239 -Uusethreads \
190 -Uuseithreads \ 240 -Uuseithreads \
191 -Uusemultiplicity \ 241 -Uusemultiplicity \
192 -Duseperlio \
193 -Uusesfio \ 242 -Uusesfio \
194 -Uuseshrplib \ 243 -Uuseshrplib \
244 -Uinstallusrbinperl \
195 -Dcppflags="$PERL_CPPFLAGS" \ 245 -A ccflags=" $PERL_CCFLAGS" \
196 -Dccflags="-g2 -fno-strict-aliasing" \ 246 -Dcc="$PERL_CC" \
197 -Doptimize="$PERL_OPTIMIZE" \ 247 -Doptimize="$PERL_OPTIMIZE" \
198 -Dldflags="$PERL_LDFLAGS" \ 248 -Dldflags="$PERL_LDFLAGS" \
199 -Dlibs="$PERL_LIBS" \ 249 -Dlibs="$PERL_LIBS" \
200 -Dprefix="$PREFIX" \ 250 -Dprefix="$PERL_PREFIX" \
201 -Dbin="$PREFIX/bin" \ 251 -Dbin="$PERL_PREFIX/bin" \
202 -Dprivlib="$PREFIX/lib" \ 252 -Dprivlib="$PERL_PREFIX/lib" \
203 -Darchlib="$PREFIX/lib" \ 253 -Darchlib="$PERL_PREFIX/lib" \
204 -Uusevendorprefix \ 254 -Uusevendorprefix \
205 -Dsitelib="$PREFIX/lib" \ 255 -Dsitelib="$PERL_PREFIX/lib" \
206 -Dsitearch="$PREFIX/lib" \ 256 -Dsitearch="$PERL_PREFIX/lib" \
207 -Usitelibexp \
208 -Uman1dir \ 257 -Uman1dir \
209 -Uman3dir \ 258 -Uman3dir \
210 -Usiteman1dir \ 259 -Usiteman1dir \
211 -Usiteman3dir \ 260 -Usiteman3dir \
212 -Dpager=/usr/bin/less \ 261 -Dpager=/usr/bin/less \
213 -Demail="$EMAIL" \ 262 -Demail="$EMAIL" \
214 -Dcf_email="$EMAIL" \ 263 -Dcf_email="$EMAIL" \
215 -Dcf_by="$EMAIL" \ 264 -Dcf_by="$EMAIL" \
265 $PERL_CONFIGURE \
266 -Duseperlio \
216 -dE || fatal "Configure failed" 267 -dE || configure_failure
217 268
218 sedreplace ' 269 sedreplace '
219 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 270 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
220 s/ *-fno-stack-protector */ /g 271 s/ *-fno-stack-protector */ /g
221 ' config.sh 272 ' config.sh
228} 279}
229 280
230build() { 281build() {
231 configure 282 configure
232 283
233 rcd "$STATICPERL/src/perl-$PERLVER" 284 rcd "$STATICPERL/src/perl-$PERL_VERSION"
234 285
235 verblock <<EOF 286 verblock <<EOF
236building $STATICPERL/src/perl-$PERLVER 287building $STATICPERL/src/perl-$PERL_VERSION
237EOF 288EOF
238 289
239 rm -f "$PREFIX/staticstamp.install" 290 rm -f "$PERL_PREFIX/staticstamp.install"
240 291
241 make || fatal "make: error while building perl" 292 "$MAKE" || fatal "make: error while building perl"
242 293
243 postbuild || fatal "postbuild hook failed" 294 postbuild || fatal "postbuild hook failed"
244} 295}
245 296
246install() { 297install() {
247 [ -e "$PREFIX/staticstamp.install" ] && return 298 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
248
249 build 299 build
250 300
251 verblock <<EOF 301 verblock <<EOF
252installing $STATICPERL/src/perl-$PERLVER 302installing $STATICPERL/src/perl-$PERL_VERSION
253to $PREFIX 303to $PERL_PREFIX
254EOF 304EOF
255 305
256 rm -rf "$PREFIX" 306 ln -sf "perl/bin/" "$STATICPERL/bin"
257 307 ln -sf "perl/lib/" "$STATICPERL/lib"
308
309 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
310 rm -rf "$PERL_PREFIX" # by this rm -rf
311
258 make install || fatal "make install: error while installing" 312 "$MAKE" install || fatal "make install: error while installing"
259 313
260 rcd "$PREFIX" 314 rcd "$PERL_PREFIX"
261 315
262 # create a "make install" replacement for CPAN 316 # create a "make install" replacement for CPAN
263 cat >"$PREFIX"/bin/cpan-make-install <<EOF 317 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
264make install UNINST=1 318"$MAKE" || exit
319
265if find blib/arch/auto -type f | grep -q -v .exists; then 320if find blib/arch/auto -type f | grep -q -v .exists; then
266 echo Probably an XS module, rebuilding perl 321 echo Probably an XS module, rebuilding perl
267 make perl 322 if "$MAKE" perl; then
323 mv perl "$PERL_PREFIX"/bin/perl~ \
268 rm -f "$PREFIX"/bin/perl 324 && rm -f "$PERL_PREFIX"/bin/perl \
269 make -f Makefile.aperl inst_perl 325 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
270 make -f Makefile.aperl map_clean 326 "$MAKE" -f Makefile.aperl map_clean
327 else
328 "$MAKE" -f Makefile.aperl map_clean
329 exit 1
330 fi
271fi 331fi
332
333"$MAKE" install UNINST=1
272EOF 334EOF
273 chmod 755 "$PREFIX"/bin/cpan-make-install 335 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
274 336
275 # try to trick CPAN into avoiding ~/.cpan completely 337 # trick CPAN into avoiding ~/.cpan completely
276 echo 1 >"$PREFIX/lib/CPAN/MyConfig.pm" 338 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
277 339
278 "$PREFIX"/bin/perl -MCPAN -e ' 340 "$PERL_PREFIX"/bin/perl -MCPAN -e '
279 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 341 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
280 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
281 CPAN::Shell->o (conf => q<init>); 343 CPAN::Shell->o (conf => q<init>);
282 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 344 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
283 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 345 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
284 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 346 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
285 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 347 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
286 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 348 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
287 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PREFIX"'/bin/cpan-make-install"); 349 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
288 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 350 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
289 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 351 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
290 CPAN::Shell->o (conf => q<commit>); 352 CPAN::Shell->o (conf => q<commit>);
291 ' || fatal "error while initialising CPAN" 353 ' || fatal "error while initialising CPAN"
292 354
355 touch "$PERL_PREFIX/staticstamp.install"
356 fi
357
358 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
293 NOCHECK_INSTALL=+ 359 NOCHECK_INSTALL=+
294 instcpan $STATICPERL_MODULES 360 instcpan $STATICPERL_MODULES
295 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 361 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
296 362
297 postinstall || fatal "postinstall hook failed" 363 postinstall || fatal "postinstall hook failed"
298 364
299 touch "$PREFIX/staticstamp.install" 365 touch "$PERL_PREFIX/staticstamp.postinstall"
366 fi
300} 367}
301 368
302############################################################################# 369#############################################################################
303# install a module from CPAN 370# install a module from CPAN
304 371
309installing modules from CPAN 376installing modules from CPAN
310$@ 377$@
311EOF 378EOF
312 379
313 for mod in "$@"; do 380 for mod in "$@"; do
314 "$PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 381 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \
315 || fatal "$mod: unable to install from CPAN" 382 || fatal "$mod: unable to install from CPAN"
316 done 383 done
317 rm -rf "$STATICPERL/build" 384 rm -rf "$STATICPERL/build"
318} 385}
319 386
331 for mod in "$@"; do 398 for mod in "$@"; do
332 echo 399 echo
333 echo $mod 400 echo $mod
334 ( 401 (
335 rcd $mod 402 rcd $mod
336 make -f Makefile.aperl map_clean >/dev/null 2>&1 403 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
337 make distclean >/dev/null 2>&1 404 "$MAKE" distclean >/dev/null 2>&1
338 "$PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 405 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
339 make || fatal "$mod: error building module" 406 "$MAKE" || fatal "$mod: error building module"
340 "$PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 407 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
341 make distclean >/dev/null 2>&1 408 "$MAKE" distclean >/dev/null 2>&1
342 exit 0 409 exit 0
343 ) || exit $? 410 ) || exit $?
344 done 411 done
345} 412}
346 413
347############################################################################# 414#############################################################################
348# do schmorpy stuff
349
350MODSRCDIR=~/src
351
352instmodsrc() {
353 for mod in "$@"; do
354 instmod_src "$MODSRCDIR/$mod"
355 done
356}
357
358install_schmorp() {
359 install
360
361 instcpan Data::Dump Term::ReadLine::Perl Term::ANSIColor Term::ReadKey
362 instcpan Digest::SHA Digest::MD6 Digest::SHA256 Digest::MD4 Digest::HMAC_MD5 Digest::HMAC_MD6 Digest::FNV
363 #instcpan Net::SSLeay # requires static -ldl
364
365 instmodsrc common-sense Crypt-Twofish2 Array-Heap Convert-Scalar Compress-LZF JSON-XS
366 instmodsrc EV Guard Async-Interrupt IO-AIO
367 instmodsrc AnyEvent AnyEvent-AIO Coro AnyEvent-HTTP
368 instmodsrc Linux-Inotify2 EV-Loop-Async
369
370 instcpan AnyEvent::HTTPD
371}
372
373#############################################################################
374# main 415# main
375 416
376podusage() { 417podusage() {
377 echo 418 echo
419
378 if [ -e "$PREFIX/bin/perl" ]; then 420 if [ -e "$PERL_PREFIX/bin/perl" ]; then
379 "$PREFIX/bin/perl" -MPod::Usage -e \ 421 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
380 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 422 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
381 2>/dev/null && exit 423 2>/dev/null && exit
382 fi 424 fi
425
383 # try whatever perl we can find 426 # try whatever perl we can find
384 perl -MPod::Usage -e \ 427 perl -MPod::Usage -e \
385 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 428 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
386 2>/dev/null && exit 429 2>/dev/null && exit
387 430
388 fatal "displaying documentation requires a working perl - try '$0 install' first" 431 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
389} 432}
390 433
391usage() { 434usage() {
392 podusage 0 435 podusage 0
393} 436}
394 437
395catmkbundle() { 438catmkbundle() {
396 { 439 {
397 read dummy 440 read dummy
398 echo "#!$PREFIX/bin/perl" 441 echo "#!$PERL_PREFIX/bin/perl"
399 cat 442 cat
400 } <<'MKBUNDLE' 443 } <<'MKBUNDLE'
401#CAT mkbundle 444#CAT mkbundle
402MKBUNDLE 445MKBUNDLE
403} 446}
404 447
405bundle() { 448bundle() {
406 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 449 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
407 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 450 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
451 CACHE="$STATICPERL/cache"
452 mkdir -p "$CACHE"
408 "$PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 453 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
409} 454}
410 455
411if [ $# -gt 0 ]; then 456if [ $# -gt 0 ]; then
412 while [ $# -gt 0 ]; do 457 while [ $# -gt 0 ]; do
413 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 458 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
414 mkdir -p "$PREFIX" || fatal "$PREFIX: cannot create" 459 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
415 460
416 command="${1#--}"; shift 461 command="${1#--}"; shift
417 case "$command" in 462 case "$command" in
463 version )
464 echo "staticperl version $VERSION"
465 ;;
418 fetch | configure | build | install | clean | distclean) 466 fetch | configure | build | install | clean | realclean | distclean)
419 verblock <<EOF
420$command
421EOF
422 "$command" 467 ( "$command" ) || exit
423 ;; 468 ;;
424 instsrc ) 469 instsrc )
425 instsrc "$@" 470 ( instsrc "$@" ) || exit
426 exit 471 exit
427 ;; 472 ;;
428 instcpan ) 473 instcpan )
429 instcpan "$@" 474 ( instcpan "$@" ) || exit
430 exit 475 exit
431 ;; 476 ;;
432 instschmorp )
433 install_schmorp
434 ;;
435 cpan ) 477 cpan )
436 install 478 ( install ) || exit
437 "$PREFIX/bin/cpan" "$@" 479 "$PERL_PREFIX/bin/cpan" "$@"
438 exit 480 exit
439 ;; 481 ;;
440 mkbundle ) 482 mkbundle )
441 install 483 ( install ) || exit
442 bundle "$@" 484 bundle "$@"
443 exit 485 exit
444 ;; 486 ;;
445 mkperl ) 487 mkperl )
446 install 488 ( install ) || exit
447 bundle --perl "$@" 489 bundle --perl "$@"
490 exit
491 ;;
492 mkapp )
493 ( install ) || exit
494 bundle --app "$@"
448 exit 495 exit
449 ;; 496 ;;
450 help ) 497 help )
451 podusage 2 498 podusage 2
452 ;; 499 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines